=begin
Copyright 		2012 EnglishTiger
Name:			MT_Core
Description:	Library of Functions Common to Merlins Toolkit Modules.
History:		1.0 (2012-02-15)	1st version
				1.1 (2012-02-22)	Various Clean-Up/Efficiency Mods
									New Functions/Modules Added
=end
Sketchup::require "sketchup"
	#------------------------------------------------------------------------------------
module MT::Plugins::MT_Toolkit
	#------------------------------------------------------------------------------------
	# CONSTANTS
	#------------------------------------------------------------------------------------
	# Set Up Module Wide Constants
	# MTCMn = Confirmation Box Texts
	MTCM0 = "The Camera Must Only Be Added To Rooms - Continue?"
	MTCM1 = "Please Confirm That You Want To Attach Your Mesh To "
	MTCM2 = "Your Mesh Has Been Atttached (Weighted) To "
	MTCM3 = "The Name Of Your Mesh File Is Now - "
	MTCM4 = "Please Save Your Model And Then Run Meshout V4.33"
	MTCM5 = "Mesh Groups CAN NOT Include\n" + "Nodes, Existing Mesh Groups, Avatars\n" + "Untextured Faces Or Faces Painted With SU's Colors\n" + "- Continue?"
	MTCM6 = "Delete Back Materials\n"
	MTCM7 = "Reverse Faces And Materials\n"
	MTCM8 = "Fix Reverse Face Materials\n"
	MTCM9 = "Fix Reversed Face Materials [Forced]\n"
	MTCM10 = "Nothing Has Been Selected!\n"
	MTCM11 = "Do You Want To Process ALL Faces In The Model?"
	MTCM12 = "Select Only The Faces You Want To Force To Flip."
	MTCM13 = "There is a Group in the selection!\n"
	MTCM14 = "There are Groups in the selection!\n"
	MTCM15 = "There is an Instance of a Component in the selection!\n"
	MTCM16 = "There are Instances of a Component in the selection!\n"
	MTCM17 = "There are Instances of Components in the selection!\n"
	MTCM18 = "Do you want to process any faces in it?"
	MTCM19 = "Do you want to process any faces in them?"
	MTCM20 = " 1 Face Fixed."
	MTCM21 = " Faces Fixed."
	MTCM22 = "There is a face oriented towards the camera!\n"
	MTCM23 = "There are faces oriented towards the camera!\n"
	MTCM24 = "Do you still want to flip the whole selection?"
	# MTIMn = Heading for User Input Dialogue
	MTIM0 = "Size/Position Of "
	MTIM1 = " Parameters"
	MTIM2 = " Node" + MTIM1
	MTIM3 = " PoseGroup" + MTIM1
	MTIM4 = "Animation" + MTIM2 + MTIM1
	MTIM5 = MTIM4 + " Path" + MTIM2 + MTIM1
	MTIM6 = "Select The Node You Wish To Attach To"
	MTIM7 = "Location For "
	MTIM8 = "Select The Bone You Wish To Attach To"
	MTIM9 = "Copies And Offsets"
	MTIM10 = "Move To:-"
	MTIM11 = "Rotate About Center Point On:-"
	MTIM12 = "Name Mesh Group As:-"
	MTIM13 = "Switch Textures:-"
	MTIM14 = "Copies, Offsets and Rotations"
	# MTUMn = Activity Name added to the Undo List via commit_operation
	MTUM0 = "Add "
	MTUM1 = MTUM0 + "Batch Of "
	MTUM2 = " Node"
	MTUM3 = MTUM2 + "s"
	MTUM4 = " Pose"  + MTUM3
	MTUM5 = MTUM0 + "Animation" + MTUM2
	MTUM6 = MTUM0 + "Animation Path" + MTUM2
	MTUM7 = "Removing Stray Lines"
	MTUM8 = "Copying Selection"
	MTUM9 = "Moving Model/Selection"
	MTUM10 = "Rotate On Axis"
	MTUM11 = "Form Mesh Group"
	MTUM12 = "Repaint"
	MTUM13 = "Material Consolidation"
	MTUM14 = "Delete Back Materials"
	MTUM15 = "Reverse Faces And Materials"
	MTUM16 = "Fix Reverse Face Materials"
	MTUM17 = "Fix Reversed Face Materials [Forced]"
	MTUM18 = "Attaching Accessory"
	MTUM19 = "Attaching Mesh"
	MTUM20 = "Attaching Nodes"
	# MTEMn - Error Message Texts
	MTEM = "Aborting Task - " + "\n"
	MTEM0 = MTEM + "Cancelled By User!"
	MTEM1 = MTEM + "One Or More Values Are Invalid!"
	MTEM2 = MTEM + "Only 1 Camera/Model Allowed!"
	MTEM3 = MTEM + "Only 1 Root Node/Model Allowed!"
	MTEM4 = MTEM + "There Are No Animation Nodes In The Model!"
	MTEM5 = MTEM + "You Must Select A Single Group Or Component!"
	MTEM6 = MTEM + "There Is Nothing In The Workspace To Attach!"
	MTEM7 = MTEM + "You Can Not Attach A Mesh With Untextured Faces!"
	MTEM8 = MTEM + "The Tube Thickness MUST Be Less Than The Radius!"
	MTEM9 = MTEM + "You Must Select A Group Or Component First!"
	MTEM10 = MTEM + "Location For Copies Is The Same As The Original!"
	MTEM11 = MTEM + "No Bone Selected!"
	MTEM12 = MTEM + "There Are No SeeThrough Nodes In The Model!"
	MTEM13 = MTEM + "There Are Less Than 2 Textures In The Model!"
	MTEM14 = MTEM + "There Are Nodes In The Selection!"
	MTEM15 = MTEM + "This Option Can Not be Used to Add/Copy Nodes!"
	MTEM16 = MTEM + "Nothing Has Been Selected!"
	MTEM17 = MTEM + "There Are "
	MTEM18 = " Untextured Faces In Your Selection!"
	MTEM19 = " Faces Painted With SU Colors In Your Selection!"
	MTEM20 = MTEM + "This Option Can Not Be Used To Rotate Root Or Camera Nodes!"
	MTEM21 = MTEM + "There Is Nothing In The Workspace To Form a Mesh Group From!"
	MTEM22 = MTEM + "Location is Outside the Face Boundaries"
	#------------------------------------------------------------------------------------
	# MT_IB_ARRAY = Array used to Build the Input Forms and Format - Validate Values
	# Array Index 0 = Prompt String
	# Array Index 1	= Input Type = the Format Function to Use for the Default Values
		# 0 = Integer
		# 1 = Float
		# 2 = Length to be Formated as a String without Units
		# 3 = Length to be Formated as a String with Units
		# 4 = Angle
		# 5 = String
		# 6 = Force the Value Displayed to be Nil
	# Array Index 2 = Validation Rule (Module) To Be Used
		# 0 = Do Not Validate
		# 1 = mt_eval_zero - Zero Not Allowed
		# 2 = mt_eval_min - Will Return Min Allowed if Less
		# 3 = mt_eval_maxmin - Checks to see if Input is Within an Allowed Range
		# 4 = mt_eval_offset - Checks to make sure an Offset is not in the Dis-Allowed Range
		# 5 = mt_capstr - Ensures that only the 1st Character of a String is Capitalized
		# 6 = mt_eval_angle - Ensures Angles are Between +-360
		# 7 = Must Contain a Value
	# Array Index 3 = Minimum Value to Check Against
	# Array Index 4 = Maximum Value to Check Against
	# N.B. -1 is used to indicate that the Array Element Value is Not Used
	MT_IB_ARRAY = [
		["Number From", 0, 2, 1, -1],
		["Number As", 0, 2, 1, -1],
		["Position X (Left/Right)", 3, 0, -1, -1],
		["Position Y (Forward/Back)", 3, 0, -1, -1],
		["Position Z (Down/Up)", 3, 0, -1, -1],
		["Offset X (Left/Right)", 3, 0, -1, -1],
		["Offset Y (Front/Back)", 3, 0, -1, -1],
		["Offset Z (Down/Up)", 3, 0, -1, -1],
		["Nodes/Row (Left to Right)", 0, 2, 1, -1],
		["Distance Between Nodes (Rows)", 3, 4, 24, 24],
		["Nodes/Column (Front to Back)", 0, 2, 1, -1],
		["Distance Between Nodes (Columns)", 3, 4, 24, 24],
		["Lower/Raise Seat by", 3, 0, -1, -1],		
		["Lower/Raise Handle Below/Above Seat by", 3, 0, -1, -1],		
		["Set Catcher+Pitcher Left/Right by", 3, 0, -1, -1],		
		["Set Catcher+Pitcher Forward/Back by", 3, 0, -1, -1],
		["Set Catcher+Pitcher Down/Up by", 3, 0, -1, -1],
		["Rotate Catcher+Pitcher on X Axis by", 4, 6, -360, 360],
		["Rotate Catcher+Pitcher on Y Axis by", 4, 6, -360, 360],
		["Rotate Catcher+Pitcher on Z Axis by", 4, 6, -360, 360],
		["Rotate PoseGroup on X Axis by", 4, 6, -360, 360],
		["Rotate PoseGroup on Y Axis by", 4, 6, -360, 360],
		["Rotate PoseGroup on Z Axis by", 4, 6, -360, 360],
		["Custom Pose Stance Name", 5, 5, -1, -1],
		["Rotate on X Axis by", 4, 6, -360, 360],
		["Rotate on Y Axis by", 4, 6, -360, 360],
		["Rotate on Z Axis by", 4, 6, -360, 360],
		["Room Pos x", 3, 0, -1, -1],
		["Room Pos y", 3, 0, -1, -1],
		["Room Pos z", 3, 0, -1, -1],
		["Room Width (Left to Right)", 3, 1, -1, -1],
		["Room Depth (Front to Back)", 3, 1, -1, -1],
		["Nodes on South(Front) Wall", 0, 2, 0, -1],
		["Nodes on West(Left) Wall", 0, 2, 0, -1],
		["Nodes on North(Back) Wall", 0, 2, 0, -1],
		["Nodes on East(Right) Wall" , 0, 2, 0, -1],
		["Distance Between Nodes", 3, 4, 24, 24],
		["Red", 0, 3, 0, 255],
		["Blue", 0, 3, 0, 255],
		["Green", 0, 3, 0, 255],
		["Attach Path to", 5, 0, -1, -1],	#Obtains Input From List
		["Width (Left to Right)", 3, 1, -1, -1],
		["Depth (Front to Back)", 3, 1, -1, -1],
		["Height", 3, 1, -1, -1],
		["Radius", 3, 1, -1, -1],
		["Segments", 0, 2, 6 , -1],
		["Sides", 0, 2, 3, -1],
		["Wall Thickness", 3, 1, -1, -1],
		["Copies", 0, 1, -1, -1],
		["Attach Mesh to ", 5, 0, -1, -1],	#Obtains Input From List
		["Attach Nodes to",5, 0, -1, -1],	#Obtains Input From List
		["Mesh Group Name - 'Mesh.'", 5, 5, -1, -1],
		["Nodes/Column (Up/Down)", 0, 2, 1, -1]
		]
	#------------------------------------------------------------------------------------
	# Functions/Modules
	#------------------------------------------------------------------------------------
	# Functions To Ensure Component Definitions are only loaded Once Per Model
	#------------------------------------------------------------------------------------
	# Check to see if the Component Definition has been loaded
	def self.mt_find_nodedef(mtname)
		mtrval = nil
		Sketchup.active_model.definitions.each do |mtdef|
			mtrval = mtdef if mtdef.name == mtname
			break if mtrval
		end # each
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Load the Component Definition From the Definition Library if it hasn't been Loaded
	def self.mt_check_nodedef(mtname)
		mtrval = mt_find_nodedef(mtname)
		if !mtrval
			mtdef = Sketchup.find_support_file mtname + ".skp" , "Components/Merlins_Library"
			if mtdef != nil
				mtrval = Sketchup.active_model.definitions.load mtdef
			end #if
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Functions to Create Component Definitions(Nodes) that are not in the Library
	#------------------------------------------------------------------------------------
	def self.mt_create_nodedef(mtname)
		# Create Nodes that are Triangles
		mtrval = mt_find_nodedef(mtname)
		if !mtrval
			mtpt0 = [0, 0, 0]
			mtpt1 = [-1.5, 4, 0]
			mtpt2 = [1.5, 4, 0]
			case mtname
				when "mo_animation"
					mtpt1 = [-2, 2, 0]
					mtpt2 = [2, 2, 0]
					mtcol = mt_check_material("mo_red", [255, 0, 0])
				when "mo_catcher"
					mtpt1 = [-1, 3, 0]
					mtpt2 = [1, 3, 0]
					mtcol = mt_check_material("mo_brown", [102, 25, 0])
				when "mo_ceiling"
					mtcol = mt_check_material("mo_violet", [199, 21, 133])
				when "mo_floor"
					mtcol = mt_check_material("mo_yellow", [255, 255, 1])
				when "mo_path"
					mtpt1 = [-1, 3, 0]
					mtpt2 = [1, 3, 0]
					mtcol = mt_check_material("mo_red", [255, 0, 0])
				when "mo_pitcher"
					mtpt1 = [-1, 3, 0]
					mtpt2 = [1, 3, 0]
					mtcol = mt_check_material("mo_green", [62, 91, 5])
				when "mo_seat"
					mtpt1 = [-2, 2, 0]
					mtpt2 = [2, 2, 0]
					mtcol = mt_check_material("mo_gold", [218, 165, 32])
				when "mo_seethru"
					mtcol = mt_check_material("mo_blue", [0, 0, 255])
				when "mo_wall"
					# Wall Nodes are Constructed Pointing Backwards
					mtpt1 = [-1, -3, 0]
					mtpt2 = [1, -3, 0]
					mtcol = mt_check_material("mo_black", [0, 0, 0])
				when "puck"
					mtcol = mt_check_material("mo_yellow", [255, 255, 1])
			end #case
			mtdef = Sketchup.active_model.definitions
			mtrval = mtdef.add mtname
			mtface = mtrval.entities.add_face mtpt0, mtpt1, mtpt2
			mtface.material = mtcol
			mtface.reverse! if mtface.normal.dot(Z_AXIS) < 0.0
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_create_cameradef(mtname)
		# Create the Camera as a Baseless Pyramid
		mtrval = mt_find_nodedef(mtname)
		if !mtrval
			mtcol = mt_check_material("mo_black", [0, 0, 0])
			mtpt0 = [0, 0, 0]
			mtpt1 = [-2, -2, -2]
			mtpt2 = [2, -2, -2]
			mtpt3 = [2, 2, -2]
			mtpt4 = [-2, 2, -2]
			mtdef = Sketchup.active_model.definitions
			mtrval = mtdef.add mtname
			mtface = mtrval.entities.add_face mtpt0, mtpt1, mtpt2
			mtface = mtrval.entities.add_face mtpt0, mtpt2, mtpt3
			mtface.material = mtcol
			mtface = mtrval.entities.add_face mtpt0, mtpt3, mtpt4
			mtface = mtrval.entities.add_face mtpt0, mtpt4, mtpt1
			mtface.material = mtcol
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_create_circledef(mtname, mtrad)
		# Create Nodes that are Circles (Mainly Root and Target Nodes)
		# 'mo-disc' is used to designate Nodes that require a Crude (6 Segment) Circle.
		mtrval = mt_find_nodedef(mtname)
		if !mtrval
			mtcol = mt_check_material("mo_red", [255, 0, 0]) if mtname == "mo_rotation"
			mtsegs = 24
			mtsegs = 6 if mtname == "mo_disc"
			mtdef = Sketchup.active_model.definitions
			mtrval = mtdef.add mtname
			mtgeom = mtrval.entities.add_circle [0, 0, 0], [0,0,1], mtrad.to_l, mtsegs
			mtface = mtrval.entities.add_face mtgeom
			mtface.material = mtcol if mtname == "mo_rotation"
			mtface.reverse! if mtface.normal.dot(Z_AXIS) < 0.0
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_create_handledef(mtname)
		# Create Nodes that are Double Triangles Arranged Point to Point
		# The Handle and Camera Target Nodes
		# For Some Odd Reason the Camera Target Node is Constructed Facing Away From The Camera.
		mtrval = mt_find_nodedef(mtname)
		if !mtrval
			mtpt0 = [0, 0, 0]
			mtpt1 = [-1, 0, -1]
			mtpt2 = [1, 0, -1]
			mtpt3 = [-1, 0, 1]
			mtpt4 = [1, 0, 1]
			if mtname == "mo_handle"
				mtcol = mt_check_material("mo_cyan", [102, 205, 170])
			else
				mtcol = mt_check_material("mo_red", [255, 0, 0])
			end #if
			mtdef = Sketchup.active_model.definitions
			mtrval = mtdef.add mtname
			mtface = mtrval.entities.add_face mtpt0, mtpt1, mtpt2
			# For Handle Nodes Only the Upper Triangle is Painted
			mtface.material = mtcol if mtname != "mo_handle"
			mtface.reverse! if mtname != "mo_handle"
			mtface = mtrval.entities.add_face mtpt0, mtpt3, mtpt4
			mtface.material = mtcol
			mtface.reverse! if mtname == "mo_handle"
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_create_lightdef(mtname)
		# Create Lighting Nodes
		# Because Meshout Picks up the "Light Color" From the Component and Not it's Faces
		# Light Nodes are Created "UnTextured"
		mtrval = mt_find_nodedef(mtname)
		if !mtrval
			mtpt0 = [0, 0, 0]
			mtpt1 = [1, 0, 0]
			mtpt2 = [0, 0, 3]
			mtpt3 = [0, 0, 1]
			mtpt4 = [0, 1, 0]
			mtdef = Sketchup.active_model.definitions
			mtrval = mtdef.add mtname
			case mtname
				when "mo_spot"
					# Spot Lights use a Crude (6 Segement) Cone Shape
					mtface = mtrval.entities.add_face mtpt0, mtpt1, mtpt2
					mtpath = mtrval.entities.add_circle mtpt0, mtpt3, 2, 6
				when "mo_omni"
					# Whilst Omni Lights use a Crude (6 Segement) Sphere
					mtgeom = mtrval.entities.add_circle mtpt0, mtpt3, 1, 6
					mtface = mtrval.entities.add_face mtgeom
					mtpath = mtrval.entities.add_circle mtpt0, mtpt4, 2, 6
			end #case
			mtface.followme mtpath
			mtrval.entities.erase_entities mtpath
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Functions Used to Handle Materials
	#------------------------------------------------------------------------------------
	# Check to see if a Material's Name exists if not then add it using the RGB Color
	def self.mt_check_material(mtname, mtcol)
		mtrval = nil
		Sketchup.active_model.materials.each do |mtmat|
			mtrval = mtmat.color if mtmat.name == mtname
			break if mtrval
		end #each
		if !mtrval
			mtmat = Sketchup.active_model.materials.add mtname
			mtmat.color = mtcol
#			mtmat.name = mtname
			mtrval = mtcol
		end #if
		return mtrval
	end #def
	# Build a List of Materials in the Current Model
	def self.mt_build_matlist
		mtmats = Sketchup.active_model.materials
		mtnames = []
		mtmats.each {|mat| mtnames.push(mat.name)}
		mtlist = mtnames.join("|")
		return mtlist
	end #def
	#------------------------------------------------------------------------------------
	# Functions Used to Establish the Number of Matching Nodes in the Model
	# These Functions are used to avoid Duplicate Node (Instance) Names
	#------------------------------------------------------------------------------------
	# Function to get the Last Node Number Used
	# Because Node Names do not follow a Single Naming Convention we use 3 Parameters
	# mtname = Name to Search For
	# mtstart = Offset in Instance Name to start of Node Name
	# mtlen = Number of Characters between the Node Name and its ID Number
	# If there are any Matching Names it returns the highest ID Number found
	def self.mt_count_nodes(mtname, mtstart, mtlen)
		mtrval = 0
		for mtent in Sketchup.active_model.entities
				if mt_ent_is_node(mtent) and mtent.name.slice(mtstart, mtname.length) == mtname
					# It's a Match on Name so extract the Node ID Number
					mtid = mtent.name.slice(mtstart + mtname.length + mtlen, mtent.name.length).to_i
					mtrval = mtid if mtid > mtrval
				end #if
				if mt_ent_is_node_group(mtent)
					mtct1 = mt_nodes_in_entity(mtent.entities, mtname, mtstart, mtlen)
					mtrval = mtct1 if mtct1 > mtrval
				end #if
				if mtent.is_a?(Sketchup::Group) or mtent.is_a?(Sketchup::ComponentInstance)
					if !mt_ent_is_node(mtent) and !mt_ent_is_node_group(mtent)
						case mtent.typename
							when "Group"
								mtct1 = mt_nodes_in_entity(mtent.entities, mtname, mtstart, mtlen)
							when "ComponentInstance"
								mtct1 = mt_nodes_in_entity(mtent.definition.entities, mtname, mtstart, mtlen)
						end #case
						mtrval = mtct1 if mtct1 > mtrval
					end #if
				end #if
		end #for
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_nodes_in_entity(mtents, mtname, mtstart, mtlen)
		mtid = 0
		for mtent in mtents
			if mt_ent_is_node(mtent) and mtent.name.slice(mtstart, mtname.length) == mtname
				# It's a Match on Name so extract the Node ID Number
				mtid = mtent.name.slice(mtstart + mtname.length + mtlen, mtent.name.length).to_i
			end #if
		end #for
		return mtid
	end #def	
	#------------------------------------------------------------------------------------	
	# Unlike mt_count_nodes this Function only counts the Number of Matches
	# mtname = Name to Search For
	# mtstart = Offset in Instance Name to start of Node Name
	def self.mt_node_count(mtname, mtstart)
		mtrval = 0
		for mtent in Sketchup.active_model.entities
			if mtent.is_a?(Sketchup::Group) or mtent.is_a?(Sketchup::ComponentInstance)
				mtrval += 1 if mtent.name.slice(mtstart, mtname.length) == mtname
			end #if
		end #for
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_ent_is_node(mtent)
		# Routine that Returns True if the Entity(mtent) is an IMVU Node
		mtrval = nil
		if mtent.is_a?(Sketchup::Group) or mtent.is_a?(Sketchup::ComponentInstance)
			mtrval = true if mtent.name[0...4] == "Omni"
			mtrval = true if mtent.name[0...4] == "Root"
			mtrval = true if mtent.name[0...4] == "seat"
			mtrval = true if mtent.name[0...4] == "Spot"
			mtrval = true if mtent.name[0...6] == "Handle"
			mtrval = true if mtent.name[0...7] == "camera."
			mtrval = true if mtent.name[0...7] == "Catcher"
			mtrval = true if mtent.name[0...7] == "Pitcher"
			mtrval = true if mtent.name[0...9] == "node.Anim"
			mtrval = true if mtent.name[0...9] == "node.Room"
			mtrval = true if mtent.name[0...9] == "node.Rota"
			mtrval = true if mtent.name[0...9] == "skeleton."
			mtrval = true if mtent.name[0...10] == "furniture."
			mtrval = true if mtent.name[0...10] == "SeeThrough"
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_ent_is_node_group(mtent)
		# Routine that Returns True if the Entity(mtent) is a Meshout or Merlin "Node/Bone Group"
		mtrval = nil
		if mtent.is_a?(Sketchup::Group) or mtent.is_a?(Sketchup::ComponentInstance)
			mtrval = true if mtent.name[0...3] == "AV_"
			mtrval = true if mtent.name[0...5] == "bone."
			mtrval = true if mtent.name[0...5] == "Dolly"
			mtrval = true if mtent.name[0...6] == "Light_"		
			mtrval = true if mtent.name[0...9] == "PoseGroup"
			mtrval = true if mtent.name[0...11] == "catch-pitch"
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_check_meshgrp(mtsel)
		# Routine that looks through Every Entity in the "Selection"
		# Looking for Enities that should not be in a Mesh Group
		# Returns Count of those Entities
		mtct1 = 0
		mtsel.each do |mtent|
			if mtent.is_a?(Sketchup::Group) or mtent.is_a?(Sketchup::ComponentInstance)
				mtct1 += 1 if mt_ent_is_not_mesh(mtent)
			end #if
		end #each
		return mtct1
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_ent_is_not_mesh(mtent)
		# Routine that Returns True if the Entity (mtent) is Not Allowed in a "Mesh Group"
		mtrval = nil
		if mtent.is_a?(Sketchup::Group) or mtent.is_a?(Sketchup::ComponentInstance)
			mtrval = true if mt_ent_is_node(mtent)
			mtrval = true if mt_ent_is_node_group(mtent)
			mtrval = true if mtent.name[0...5] == "Mesh."
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# User Input Validation Functions
	#------------------------------------------------------------------------------------
	# Function to Ensure that a User Input Value is not below the Allowed Minimum
	def self.mt_eval_min(mtnum, mtmin)
		mtrval = mtnum
		mtrval = mtmin if mtnum < mtmin
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Function to Ensure that a User Input Value is Between the Allowed Min and Max Values
	# Returns either the min or max Allowed Value if the Value is out of Range
	def self.mt_eval_maxmin(mtnum, mtmin, mtmax)
		mtrval = mtnum
		mtrval = mtmin if mtnum < mtmin
		mtrval = mtmax if mtnum > mtmax
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Function to Ensure that a User Input Value (Offset) is Not Less than the Min Allowed
	# Used to enure there is a Minimum Spacing of 24" Between Nodes.
	def self.mt_eval_offset(mtival, mtmin)
		if mtival < 0
			mtsign = -1
		else
			mtsign = 1
		end #if
		if mtival.abs < mtmin
			mtrval = mtmin * mtsign
		else
			mtrval = mtival
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Function used to Ensure that a User Input Value is Between +- 360 Degrees
	# Returns 0 if the Absolute Value of the Angle is 360 or Higher
	def self.mt_eval_angle(mtival, mtmin, mtmax)
		mtrval = mtival
		mtrval = 0 if mtival <= mtmin || mtival >= mtmax
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Function used to Ensure that a Value is Not Zero (Nil)
	def self.mt_eval_zero(mtival)
		mtrval = nil
		mtrval = mtival if mtival > 0
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Function used to Ensure only the 1st Character of an Input String is Capitalized
	# This is done to make sure Properly Capitalized Strings are passed to IMVU
	def self.mt_capstr(mtstring)
		mtstring.downcase! 		# Force the String to be Lowercase
		mtstring.capitalize! 	# Then Capitalize only the Initial Letter
	end
	#------------------------------------------------------------------------------------
	# Function used to convert Measurements to Lengths, in Local Units, then to Strings
	# Although SketchUp's .to_l Conversion Function is the Simplest way to Convert to
	# Local Units it uses the User/Template Specified Precision Value so we use
	# the (val.to_l).to_s).to_f).to_s Combination to remove the Length Units and
	# Trailing Zero's from the Default Value String we send to the Input Box.
	def self.mt_numstr(mtnum, mttype)
		if mttype == 2
			mtrval = (((mtnum.to_l).to_s).to_f).to_s 	# No Length Units Indicator
		else
			mtrval = (mtnum.to_l).to_s 					# With Length Units Indicator
		end #if
		return mtrval
	end #def
	#------------------------------------------------------------------------------------
	# Function used to Set up the UI Messagebox and Validate the Input
	# uiprompts is an Array of the Promts to be Used
	# uidefaults is an Array of the Default Values to be shown on the Input Form
	# uiheader is the Heading for the Form
	# uilist is the List of Values Allowed for a Drop-Down List
	def self.mt_user_input(uiprompts, uidefaults, uiheader, uilist)
		# Build up the Arrays used for the Input Form and Validation Functions
		mtlen = uiprompts.length
		mtprmpts = Array.new mtlen		# Form Prompts
		mtdvals = Array.new mtlen		# Form Initial/Default Values
		mttype = Array.new mtlen		# Input Type
		mtivalr = Array.new mtlen		# Validation Routine Flag
		mtmin = Array.new mtlen			# Minimum Allowed Value
		mtmax = Array.new mtlen			# Maximum Allowed Value
		for mti in (0...mtlen)
			mtval = uiprompts[mti].to_i
			mtprmpts[mti] = MT_IB_ARRAY[mtval][0] + "  "
			mttype[mti] = MT_IB_ARRAY[mtval][1]
			# Format the Default Values that Appear on the Form
			case mttype[mti]
				when 2, 3
					mtdvals [mti] = mt_numstr(uidefaults[mti].to_i, mttype[mti])
				when 4
					mtdvals [mti] = uidefaults[mti].to_f
				when 6
					mtdvals [mti] = nil
				else
					mtdvals [mti] = uidefaults[mti]
			end #case
			mtivalr[mti] = MT_IB_ARRAY[mtval][2]
			# If it's the 1st 2 entries in the Control Array (Node Number)
			# Force Node Numbers (from uidefaults array) into imin array.
			if mtval <= 1
				mtmin[mti] = uidefaults[mti]
			else
				mtmin[mti] = MT_IB_ARRAY[mtval][3]
			end #if
			mtmax[mti] = MT_IB_ARRAY[mtval][4]
		end #for
		case uiprompts[0].to_i
			when 49, 50
				mtrval = UI.inputbox mtprmpts, mtdvals, [uilist, ""], uiheader
			when 40
				mtrval = UI.inputbox mtprmpts, mtdvals, [uilist, "", "", "", "" ,"" ,"" ,""], uiheader
			else
				mtrval = UI.inputbox mtprmpts, mtdvals, uiheader
		end #case
		if !mtrval
			UI.messagebox MTEM0, MB_OK
			return mtrval
		end #if
		mtinput = Array.new mtrval
		mtlen = mtinput.length
#		puts 'is', mtinput, mtlen
		for mti in (0...mtlen)
			# Format the User Input
#			puts 'format', mttype[mti], mtinput[mti], mtivalr[mti]
			case mttype[mti]
				when 0			#Integer
					mtinput[mti] = mtinput[mti].to_i
				when 1, 4		#Float/Angle
					mtinput[mti] = mtinput[mti].to_f
				when 2, 3, 6	#Length
					mtinput[mti] = mtinput[mti].to_l
				else			#String
					mtinput[mti] = mtinput[mti].to_s
			end #case
			# Then Evaluate it.
			case mtivalr[mti]
				when 1			#Value Can Not Be Zero
					mtrval = mt_eval_zero(mtinput[mti])
				when 2			#Ensure Value is not Below the Minimum
					mtrval = mt_eval_min(mtinput[mti], mtmin[mti])
				when 3			#Ensure Value is in Required Range
					mtrval = mt_eval_maxmin(mtinput[mti], mtmin[mti], mtmax[mti])
				when 4			#Ensure Offset is not between -24" and + 24"
					mtrval = mt_eval_offset(mtinput[mti], mtmin[mti])
				when 5			#Ensure Only 1st Letter of a String Is Uppercase
					mtrval = mt_capstr(mtinput[mti])
				when 6			#Ensure Rotation is between +-360
					mtrval = mt_eval_angle(mtinput[mti], mtmin[mti], mtmax[mti])
				else			#String
					mtrval = mtinput[mti]
			end #case
			if !mtrval
				UI.messagebox MTEM1, MB_OK
				return mtrval
			end #if
			mtinput[mti] = mtrval
		end #for
#		puts 'now', mtinput
		return mtinput
	end #def
	#------------------------------------------------------------------------------------
	# Functions used to Set Options on Merlin's Context Menu Available/Not Available
	#------------------------------------------------------------------------------------
	def self.mtcm_check_group(mttype)
		# Check that a Group or Component Has Been Selected
		mtcmsel = Sketchup.active_model.selection
		mtrval = mtcmsel.find {|mtcment| mtcment.is_a?(Sketchup::Group) or mtcment.is_a?(Sketchup::ComponentInstance)}
		mtrval ? MF_ENABLED : MF_GRAYED
	end #def
	#------------------------------------------------------------------------------------
	def self.mtcm_check_selection()	
	# Make sure the Selection/Workspace is not Empty
		mtrval = (Sketchup.active_model.selection.length != 0)
		mtrval ? MF_ENABLED : MF_GRAYED
	end #def
	#------------------------------------------------------------------------------------
	# Functions used by Merlin's Views Toolbar
	#------------------------------------------------------------------------------------
	def self.mttb_set_view(mtflag)
		case mtflag
			when 0 #Top
				Sketchup.send_action("viewTop:")
			when 1 #Front
				Sketchup.send_action("viewFront:")
			when 2 #Right
				Sketchup.send_action("viewRight:")
			when 3 #Back
				Sketchup.send_action("viewBack:")
			when 4 #Left
				Sketchup.send_action("viewLeft:")
			when 5 #Bottom
				Sketchup.send_action("viewBottom:")
			when 6 #Iso Auto
				Sketchup.send_action("viewIso:")
		end #case
	end #def
	#------------------------------------------------------------------------------------
	# Functions used by Merlin's Toggle Units Toolbar/Menu
	#------------------------------------------------------------------------------------
	def self.mttb_toggle_units(mtint)
	    model = Sketchup.active_model
	    case mtint
			when 0, 1, 2, 3, 4
				model.options['UnitsOptions'][2] = mtint
			when 5, 6, 7, 8
				mtrval = mtint - 5
				case mtrval
					when 1; model.options['UnitsOptions']['LengthUnit'] = 1
					when 2; model.options['UnitsOptions']['LengthUnit'] = 0
					when 3; model.options['UnitsOptions']['LengthUnit'] = 1
				end #case
				model.options['UnitsOptions']['LengthFormat'] = mtrval
	    end #case
	    model.active_view.invalidate
	    UI.refresh_inspectors
	    return nil
	end #def
	#------------------------------------------------------------------------------------
	def self.mttb_toggle_units_validation(mtint)
		case mtint
			when 0, 1, 2, 3, 4
				if Sketchup.active_model.options['UnitsOptions']['LengthFormat'] != 0
					if Sketchup.active_model.options['UnitsOptions']['LengthUnit'] == mtint
						MF_CHECKED
					else
						MF_GRAYED
					end #if
				else
					if Sketchup.active_model.options['UnitsOptions']['LengthUnit'] == mtint
						MF_CHECKED
					else
						MF_UNCHECKED
					end #if
				end #if
			when 5, 6, 7, 8
				mtrval = mtint - 5
				if Sketchup.active_model.options['UnitsOptions']['LengthFormat'] == mtrval
					MF_CHECKED
				else
					MF_UNCHECKED
				end #if
		end #case
	end #def
	#------------------------------------------------------------------------------------
	def self.mttb_toggle_length_precision(mtint)
	    model = Sketchup.active_model
	    return if not [1,-1].index(mtint)
	    mtlp = model.options["UnitsOptions"]["LengthPrecision"]
	    if 0 <= (mtlp + mtint) && (mtlp + mtint) <= 8
		model.options["UnitsOptions"]["LengthPrecision"] = mtlp + mtint
		puts "Drawing precision = " + (mtlp + mtint).to_s
		mtf = "Units Precision: %.#{mtlp + mtint}f (#{mtlp + mtint})"
		mtstr = mtf % [0]
		Sketchup.status_text = mtstr
	    end
	    model.active_view.invalidate
	    UI.refresh_inspectors
	end #def
	#------------------------------------------------------------------------------------
	def self.mttb_length_precision_validation_upper
	    mtlp = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
	    if mtlp  >= 8 
			MF_GRAYED
	    end #if
	end #def
	#------------------------------------------------------------------------------------
	def self.mttb_length_precision_validation_lower
	    mtlp = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
	    if mtlp <= 0 
			MF_GRAYED
	    end #if
	end #def
	#------------------------------------------------------------------------------------
	def self.mttb_display_unit_format
	    model = Sketchup.active_model
	    if model.options["UnitsOptions"]["SuppressUnitsDisplay"] == true
			model.options["UnitsOptions"]["SuppressUnitsDisplay"] = false
	    else
			model.options["UnitsOptions"]["SuppressUnitsDisplay"] = true
	    end #if
	    model.active_view.invalidate
	    UI.refresh_inspectors
	end #def
	#------------------------------------------------------------------------------------
	def self.mttb_display_unit_format_validation
	    if Sketchup.active_model.options["UnitsOptions"]["SuppressUnitsDisplay"] == true
			MF_UNCHECKED
	    else
			MF_CHECKED
	    end #if
	end #def
	#------------------------------------------------------------------------------------
	# Functions used to Make Merlin's Activities Single Click Undoable
	#------------------------------------------------------------------------------------
	def self.mt_start(mtmsg)
		# Make use of the SU7 speed boost with start_operation while making sure it works in SU6.
		if Sketchup.version.split(".")[0].to_i >= 7
			Sketchup.active_model.start_operation(mtmsg, true, true)
		else
			Sketchup.active_model.start_operation(mtmsg)
		end
		Sketchup.set_status_text(mtmsg)
	end #def
	#------------------------------------------------------------------------------------
	def self.mt_end()
		# Handles the commit_operation
		# Blanks out the Status Line
		# Makes the Selection Tool Active
		Sketchup.active_model.commit_operation
		Sketchup.set_status_text("")
		Sketchup.send_action("selectSelectionTool:")
	end #def
# -------- End of Common Functions
end #module