=begin
Copyright 		2012 EnglishTiger
Name:			MT_Menu
Description:	Builds the Menu's used to Invoke the Individual Merlin's Toolkit Modules/Functions.
History:		1.0 (2012-02-15)	1st version
				1.1 (2012-03-23)	Added New Options + Context Menu
=end
	Sketchup::require "sketchup"
	Sketchup::require "MT_Toolkit/MT_Core"
	Sketchup::require "MT_Toolkit/MT_Meshmatic"
	Sketchup::require "MT_Toolkit/MT_Nodematic"
	Sketchup::require "MT_Toolkit/MT_Toolbox"
module MT::Plugins::MT_Toolkit
	unless file_loaded?( File.basename(__FILE__) )
		# Build/Expose Plugins Menu/SubMenus
		UI.menu("Plugins").add_separator
		mt_menu = UI.menu("Plugins").add_submenu("Merlin's Toolkit")
		#-------------------------------------------------------------------------------
		# Expose Merlin's NodeGen
		mt_submenu = mt_menu.add_submenu("Merlin's NodeMatic v1.0")
		mt_submenu.add_item("Add Standing PoseGroup") { self.mt_add_pose("Standing") }
		mt_submenu.add_item("Add Standing PoseGroups (Batch)") { self.mt_add_pose_batch("Standing") }
		mt_submenu.add_item("Add Sitting PoseGroup") { self.mt_add_pose("Sitting") }
		mt_submenu.add_item("Add Sitting PoseGroups (Batch)") { self.mt_add_pose_batch("Sitting") }
		mt_submenu.add_item("Add Custom PoseGroup") { self.mt_add_pose("Custom") }
		mt_submenu.add_separator
		mt_submenu.add_item("Add Ceiling Node") { self.mt_add_furn("Ceiling") }
		mt_submenu.add_item("Add Ceiling Nodes (Batch)") { self.mt_add_furn_batch("Ceiling") }
		mt_submenu.add_item("Add Floor Node") { self.mt_add_furn("Floor") }
		mt_submenu.add_item("Add Floor Nodes (Batch)") { self.mt_add_furn_batch("Floor") }
		mt_submenu.add_item("Add Wall Node") { self.mt_add_furn("Wall") }
		mt_submenu.add_item("Add Wall Nodes (Batch)") { self.mt_add_wall_batch("Wall") }
		mt_submenu.add_item("Add Wall Nodes (Room)") { self.mt_add_wall_room("Wall") }
		mt_submenu.add_separator
		mt_submenu.add_item("Add Omni Light") {self.mt_add_lights("Omni")  }
		mt_submenu.add_item("Add Spot Light") {self.mt_add_lights("Spot")  }
		mt_submenu.add_separator
		mt_submenu.add_item("Add Camera Dolly (Node Set)") {self.mt_add_camera()  }
		mt_submenu.add_item("Add Furniture Root Node") { self.mt_add_root("Root")  }
		mt_submenu.add_item("Add Room Root Node") { self.mt_add_root("Room")  }
		#-------------------------------------------------------------------------------
		# Expose Merlin's MeshMatic
		mt_submenu = mt_menu.add_submenu("Merlin's MeshMatic v1.0")
		mt_submenu.add_item("Add Box") { self.mt_build_box("Box") }
		mt_submenu.add_item("Add Cone") { self.mt_build_cone("Cone") }
		mt_submenu.add_item("Add Cylinder") { self.mt_build_circle("Cylinder") }
		mt_submenu.add_item("Add 3D Polygon") { self.mt_build_polygon("3DPolygon") }
		mt_submenu.add_item("Add Pyramid") { self.mt_build_box("Pyramid") }
		mt_submenu.add_item("Add Room") { self.mt_build_box("Room") }
		mt_submenu.add_item("Add Sphere") { self.mt_build_sphere("Sphere") }
		mt_submenu.add_item("Add Tube") { self.mt_build_circle("Tube") }
		mt_submenu.add_separator
		mt_submenu.add_item("Add Circle") { self.mt_build_circle("Circle") }
		mt_submenu.add_item("Add 2D Polygon (Face)") { self.mt_build_polygon("2DPolygon") }
		mt_submenu.add_item("Add Rectangle") { self.mt_build_box("Rectangle") }
		#-------------------------------------------------------------------------------
		# Expose Merlin's ToolBox
		mt_submenu = mt_menu.add_submenu("Merlin's ToolBox v1.0")
		mt_submenu.add_item("Center on Origin") { self.mt_move_model("Center") }
		mt_submenu.add_item("Move to Center") { self.mt_move_model("Middle") }
		mt_submenu.add_item("Move to Origin") { self.mt_move_model("Origin") }
		mt_submenu.add_item("Move to User Specified Location") { self.mt_move_model("User") }
		mt_submenu.add_separator
		mt_submenu.add_item("Add Copy of Selected Component or Group") { self.mt_move_copy() }
		mt_submenu.add_separator
		mt_submenu.add_item("Rotate About Center Point on Axis") { self.mt_rotate_model() }
		mt_submenu.add_separator
		mt_submenu.add_item("Add Guinevere (Standing)") { self.mt_add_comp("Guinevere") }
		mt_submenu.add_item("Add Lancelot (Sitting)") { self.mt_add_comp("Lancelot") }
		mt_submenu.add_item("Add SkyDome") { self.mt_add_comp("Skydome") }
		mt_submenu.add_separator
		mt_submenu.add_item("Count Triangles") { self.mt_triangle_counter() }
		mt_submenu.add_item("Remove Stray Lines") { self.mt_clean_model() }
		#-------------------------------------------------------------------------------
		# Expose Merlin's Toggle Units
		mt_submenu = mt_menu.add_submenu("Merlin's ToggleUnits v1.0")
	    mt_submenu.add_item("Decimal") { mttb_toggle_units(5) }
	    mt_submenu.add_item("Architectural") { mttb_toggle_units(6) }
	    mt_submenu.add_item("Fractional") { mttb_toggle_units(7) }
	    mt_submenu.add_item("Engineering") { mttb_toggle_units(8) }
	    mt_submenu.add_separator
	    mt_submenu.add_item("Inch") { mttb_toggle_units(0) }
	    mt_submenu.add_item("Feet") { mttb_toggle_units(1) }
	    mt_submenu.add_item("Millimetre") { mttb_toggle_units(2) }
	    mt_submenu.add_item("Centimetre") { mttb_toggle_units(3) }
	    mt_submenu.add_item("Metre") { mttb_toggle_units(4) }
	    mt_submenu.add_separator
	    mt_submenu.add_item("Decrease Precision") { mttb_toggle_length_precision(-1) }
	    mt_submenu.add_item("Increase Precision") { mttb_toggle_length_precision(1) }
	    mt_submenu.add_separator
	    mt_submenu.add_item("Display Units Format") {mttb_display_unit_format }
		#-------------------------------------------------------------------------------
		# Build/Expose Context Menu/SubMenu
		UI.add_context_menu_handler do |mt_context|
			mt_context.add_separator
				# Expose Some of Merlin's ToolBox
			mt_cmenu = mt_context.add_submenu( "Merlin's ToolBox" )
				mtitem = mt_cmenu.add_item("Center on Origin") { self.mt_move_model("Center") }
				mt_cmenu.set_validation_proc(mtitem) {self.mtcm_check_selection() }
				mtitem = mt_cmenu.add_item("Move to Center") { self.mt_move_model("Middle") }
				mt_cmenu.set_validation_proc(mtitem) {self.mtcm_check_selection() }
				mtitem = mt_cmenu.add_item("Move to Origin") { self.mt_move_model("Origin") }
				mt_cmenu.set_validation_proc(mtitem) {self.mtcm_check_selection() }
				mtitem = mt_cmenu.add_item("Move to User Specified Location") { self.mt_move_model("User") }
				mt_cmenu.set_validation_proc(mtitem) {self.mtcm_check_selection() }
				mt_cmenu.add_separator
				mtitem = mt_cmenu.add_item("Add Copy/Copies of Selected Component/Group") { self.mt_move_copy()}
				mt_cmenu.set_validation_proc(mtitem) {self.mtcm_check_group("Add")}
				mt_cmenu.add_separator
				mtitem = mt_cmenu.add_item("Rotate About Center Point on Axis") { self.mt_rotate_model() }
				mt_cmenu.set_validation_proc(mtitem) {self.mtcm_check_group("Turn")}
		end #do
		# Build/Expose Toolbar
		mtpath = "MT_Images/mt_"
		mtexts = "_16.png"
		mtextl = "_24.png"
		#-------------------------------------------------------------------------------
		mttb = UI::Toolbar.new("Merlin's Views")
			mtname = "ViewIso"
			mtvname = "Iso"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(6) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "ViewTop"
			mtvname = "Top"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(0) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "ViewBottom"
			mtvname = "Bottom"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(5) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "ViewFront"
			mtvname = "Front"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(1) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "ViewRight"
			mtvname = "Right"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(2) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "ViewBack"
			mtvname = "Back"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(3) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "ViewLeft"
			mtvname = "Left"
			mtcmd = UI::Command.new(mtvname) {self.mttb_set_view(4) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname
			mtcmd.small_icon = mtpath + mtname + mtexts
			mtcmd.large_icon = mtpath + mtname + mtextl
			mttb.add_item mtcmd
		#-------------------------------------------------------------------------------
	    mtstate = mttb.get_last_state
	    if (mtstate == TB_NEVER_SHOWN)
			mttb.show 
	    elsif (mtstate == TB_VISIBLE)
			mttb.restore
	    end
		#-------------------------------------------------------------------------------
		mttb = UI::Toolbar.new("Merlin's ToggleUnits")
			mtname = "Decimal"
			mtvname = "Measurement Format -> "
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(5) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname 
			mtcmd.small_icon = mtpath + "dec" + mtexts
			mtcmd.large_icon = mtpath + "dec" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(5) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Architectural"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(6) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "arc" + mtexts
			mtcmd.large_icon = mtpath + "arc" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(6) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Fractional"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(8) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "fra" + mtexts
			mtcmd.large_icon = mtpath + "fra" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(8) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Engineering"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(7) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "eng" + mtexts
			mtcmd.large_icon = mtpath + "eng" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(7) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mttb.add_separator
			mttb.add_separator
			#-------------------------------------------------------------------------------
			mtname = "Inch"
			mtvname = "Measurement Unit -> "
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(0) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "in" + mtexts
			mtcmd.large_icon = mtpath + "in" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(0) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Feet"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(1) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "ft" + mtexts
			mtcmd.large_icon = mtpath + "ft" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(1) }
			mttb.add_item mtcmd
			mttb.add_separator
			#-------------------------------------------------------------------------------
			mtname = "Millimetre"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(2) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "mm" + mtexts
			mtcmd.large_icon = mtpath + "mm" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(2) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Centimetre"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(3) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "cm" + mtexts
			mtcmd.large_icon = mtpath + "cm" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(3) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Metre"
			mtcmd = UI::Command.new(mtname) { mttb_toggle_units(4) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtvname + mtname
			mtcmd.small_icon = mtpath + "me" + mtexts
			mtcmd.large_icon = mtpath + "me" + mtextl
			mtcmd.set_validation_proc { mttb_toggle_units_validation(4) }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mttb.add_separator
			mttb.add_separator
			#-------------------------------------------------------------------------------
			mtname = "Decrease Precision"		
			mtcmd = UI::Command.new(mtname) { mttb_toggle_length_precision(-1) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtname
			mtcmd.small_icon = mtpath + "minus" + mtexts
			mtcmd.large_icon = mtpath + "minus" + mtextl
			mtcmd.set_validation_proc { mttb_length_precision_validation_lower }
			mttb.add_item mtcmd
			#-------------------------------------------------------------------------------
			mtname = "Increase Precision"		
			mtcmd = UI::Command.new(mtname) { mttb_toggle_length_precision(1) }
			mtcmd.tooltip = mtcmd.status_bar_text = mtname
			mtcmd.small_icon = mtpath + "plus" + mtexts
			mtcmd.large_icon = mtpath + "plus" + mtextl
			mtcmd.set_validation_proc { mttb_length_precision_validation_upper }
			mttb.add_item mtcmd
			mttb.add_separator
			#-------------------------------------------------------------------------------
			mtname = "Display Units Format"
			mtcmd = UI::Command.new(mtname) { mttb_display_unit_format }
			mtcmd.tooltip = mtcmd.status_bar_text = mtname
			mtcmd.small_icon = mtpath + "duf" + mtexts
			mtcmd.large_icon = mtpath + "duf" + mtextl
			mtcmd.set_validation_proc { mttb_display_unit_format_validation }
			mttb.add_item mtcmd
		#-------------------------------------------------------------------------------
	    mtstate = mttb.get_last_state
	    if (mtstate == TB_NEVER_SHOWN)
			mttb.show 
	    elsif (mtstate == TB_VISIBLE)
			mttb.restore
	    end
		#-------------------------------------------------------------------------------
	end  # unless file
end # module
		#-------------------------------------------------------------------------------
	file_loaded( File.basename(__FILE__) )